// WARNING! All changes made in this file will be lost!
// Created from 'calls.style' by 'codegen_style'
//
// This file is part of Desktop App Toolkit,
// a set of libraries for developing nice desktop applications.
//
// For license and copyright information please follow this link:
// https://github.com/desktop-app/legal/blob/master/LEGAL
//
#pragma once

#include "ui/style/style_core.h"

#include "styles/style_widgets.h"

namespace style {
namespace internal {

void init_style_calls(int scale);

} // namespace internal

struct IconButton;
struct FlatLabel;
struct CallButton;
struct InfiniteRadialAnimation;
struct LabelSimple;
struct InputField;
struct WindowTitle;
struct Toast;
struct RippleAnimation;
struct Menu;
struct Shadow;
struct PanelAnimation;
struct PopupMenu;
struct ShortInfoCover;
struct InnerDropdown;
struct DropdownMenu;
struct RoundCheckbox;
struct RoundImageCheckbox;
struct PeerListItem;
struct PeerList;
struct MultiSelect;
struct SettingsButton;
struct UserpicButton;
struct CrossLineAnimation;
struct GroupCallUserpics;
struct RoundButton;
struct Box;
struct LevelMeter;
struct Check;
struct Radio;
struct Checkbox;
struct Toggle;
struct MediaSlider;
struct ArcsAnimation;
struct Tooltip;
struct ImportantTooltip;
struct CalendarColors;

struct CallSignalBars {
	int width;
	int radius;
	int skip;
	int min;
	int max;
	style::color color;
	double inactiveOpacity;
};

struct CallBodyLayout {
	int height;
	int photoTop;
	int photoSize;
	int nameTop;
	int statusTop;
	int muteStroke;
	int muteSize;
	style::point mutePosition;
};

struct CallMuteButton {
	style::CallButton active;
	style::CallButton muted;
	int labelAdditional;
	style::FlatLabel sublabel;
	int labelsSkip;
	int sublabelSkip;
	style::size lottieSize;
	int lottieTop;
};

struct GroupCallVideoTile {
	int shadowHeight;
	style::point namePosition;
	style::CrossLineAnimation pin;
	style::point pinPosition;
	style::margins pinPadding;
	style::point pinTextPosition;
	style::icon back;
	style::point iconPosition;
};

} // namespace style

namespace st {
extern const int &callWidthMin;
extern const int &callHeightMin;
extern const int &callWidth;
extern const int &callHeight;
extern const int &callBottomControlsHeight;
extern const style::CallBodyLayout &callBodyLayout;
extern const style::CallBodyLayout &callBodyWithPreview;
extern const style::icon &callMutedPeerIcon;
extern const style::size &callOutgoingPreviewMin;
extern const style::size &callOutgoingPreview;
extern const style::size &callOutgoingPreviewMax;
extern const style::size &callOutgoingDefaultSize;
extern const int &callInnerPadding;
extern const style::margins &callFingerprintPadding;
extern const int &callFingerprintSkip;
extern const int &callFingerprintSignalBarsSkip;
extern const style::margins &callSignalBarsPadding;
extern const int &callFingerprintTop;
extern const int &callFingerprintBottom;
extern const style::icon &callTooltipMutedIcon;
extern const style::point &callTooltipMutedIconPosition;
extern const style::margins &callTooltipPadding;
extern const style::IconButton &callButton;
extern const style::FlatLabel &callButtonLabel;
extern const style::CallButton &callAnswer;
extern const style::CallButton &callStartVideo;
extern const style::CallButton &callHangup;
extern const style::CallButton &callCancel;
extern const style::CallButton &callMicrophoneMute;
extern const style::CallButton &callMicrophoneUnmute;
extern const style::CallButton &callCameraMute;
extern const style::CallButton &callCameraUnmute;
extern const style::CallButton &callScreencastOn;
extern const style::CallButton &callScreencastOff;
extern const int &callBottomShadowSize;
extern const style::FlatLabel &callMuteButtonLabel;
extern const style::IconButton &callMuteButtonActiveInner;
extern const style::IconButton &callMuteButtonSmallActiveInner;
extern const style::CallButton &callMuteButtonActive;
extern const style::CallMuteButton &callMuteButton;
extern const style::CallButton &callMuteButtonSmallActive;
extern const style::CallMuteButton &callMuteButtonSmall;
extern const int &callMuteMinorBlobMinRadius;
extern const int &callMuteMinorBlobMaxRadius;
extern const int &callMuteMajorBlobMinRadius;
extern const int &callMuteMajorBlobMaxRadius;
extern const int &callMuteBlobRadiusForDiameter;
extern const style::icon &callMuteToFullScreen;
extern const style::icon &callMuteFromFullScreen;
extern const style::InfiniteRadialAnimation &callConnectingRadial;
extern const style::FlatLabel &callName;
extern const style::FlatLabel &callStatus;
extern const style::FlatLabel &callRemoteAudioMute;
extern const int &callRemoteAudioMuteSkip;
extern const int &callBarHeight;
extern const style::IconButton &callBarMuteToggle;
extern const int &callBarRightSkip;
extern const int &callBarSkip;
extern const style::IconButton &callBarHangup;
extern const style::LabelSimple &callBarLabel;
extern const style::FlatLabel &callBarInfoLabel;
extern const int &callBarLabelTop;
extern const style::point &callArrowPosition;
extern const style::icon &callArrowIn;
extern const style::icon &callArrowOut;
extern const style::icon &callArrowMissed;
extern const int &callArrowSkip;
extern const style::IconButton &callReDial;
extern const style::IconButton &callCameraReDial;
extern const style::IconButton &callGroupCall;
extern const style::margins &callRatingPadding;
extern const style::IconButton &callRatingStar;
extern const style::icon &callRatingStarFilled;
extern const int &callRatingStarTop;
extern const style::InputField &callRatingComment;
extern const int &callRatingCommentTop;
extern const style::margins &callDebugPadding;
extern const style::FlatLabel &callDebugLabel;
constexpr int callPanelDuration = 150;
extern const style::CallSignalBars &callPanelSignalBars;
extern const style::CallSignalBars &callBarSignalBars;
extern const style::IconButton &callTitleButton;
extern const style::icon &callTitleMinimizeIcon;
extern const style::icon &callTitleMinimizeIconOver;
extern const style::icon &callTitleMaximizeIcon;
extern const style::icon &callTitleMaximizeIconOver;
extern const style::icon &callTitleRestoreIcon;
extern const style::icon &callTitleRestoreIconOver;
extern const style::icon &callTitleCloseIcon;
extern const style::icon &callTitleCloseIconOver;
extern const style::WindowTitle &callTitle;
extern const style::icon &callTitleShadowRight;
extern const style::icon &callTitleShadowLeft;
extern const style::Toast &callErrorToast;
extern const int &groupCallWidth;
extern const int &groupCallHeight;
extern const int &groupCallWidthRtmp;
extern const int &groupCallWidthRtmpMin;
extern const int &groupCallHeightRtmp;
extern const int &groupCallHeightRtmpMin;
extern const style::RippleAnimation &groupCallRipple;
extern const style::Menu &groupCallMenu;
extern const style::Menu &groupCallFinishMenu;
extern const style::Shadow &groupCallMenuShadow;
extern const style::PanelAnimation &groupCallPanelAnimation;
extern const style::PopupMenu &groupCallPopupMenu;
extern const style::PopupMenu &groupCallPopupMenuWithVolume;
extern const style::Menu &groupCallPopupVolumeMenu;
extern const int &groupCallMenuCoverSize;
extern const style::Menu &groupCallPopupCoverMenu;
extern const style::PopupMenu &groupCallPopupMenuWithCover;
extern const style::ShortInfoCover &groupCallMenuCover;
extern const style::FlatLabel &groupCallMenuAbout;
extern const style::margins &groupCallRecordingTimerPadding;
extern const style::font &groupCallRecordingTimerFont;
extern const style::InnerDropdown &groupCallInnerDropdown;
extern const style::DropdownMenu &groupCallDropdownMenu;
extern const style::RoundCheckbox &groupCallMembersListCheck;
extern const style::RoundImageCheckbox &groupCallMembersListCheckbox;
extern const style::PeerListItem &groupCallMembersListItem;
extern const style::PeerListItem &groupCallNarrowMembersListItem;
extern const style::PeerList &groupCallMembersList;
extern const style::margins &groupCallInviteDividerPadding;
extern const style::PeerListItem &groupCallInviteMembersListItem;
extern const style::PeerList &groupCallInviteMembersList;
extern const style::PeerList &groupCallJoinAsList;
extern const style::PeerList &peerListJoinAsList;
extern const style::MultiSelect &groupCallMultiSelect;
extern const style::InputField &groupCallField;
extern const style::InputField &groupCallShareBoxComment;
extern const style::PeerList &groupCallShareBoxList;
extern const int &groupCallMembersTop;
extern const int &groupCallTitleTop;
extern const int &groupCallSubtitleTop;
extern const int &groupCallWideVideoTop;
extern const style::SettingsButton &groupCallAddMember;
extern const style::icon &groupCallAddMemberIcon;
extern const style::FlatLabel &groupCallSubtitleLabel;
extern const style::FlatLabel &groupCallTitleLabel;
extern const int &groupCallTitleSeparator;
extern const style::FlatLabel &groupCallVideoLimitLabel;
extern const int &groupCallMembersWidthMax;
extern const int &groupCallRecordingMark;
extern const int &groupCallRecordingMarkSkip;
extern const int &groupCallRecordingMarkTop;
extern const style::point &groupCallMenuTogglePosition;
extern const style::IconButton &groupCallMenuToggle;
extern const style::UserpicButton &groupCallJoinAsToggle;
extern const style::point &groupCallMenuPosition;
extern const style::point &groupCallWideMenuPosition;
extern const style::IconButton &groupCallActiveButton;
extern const int &groupCallMemberButtonSkip;
extern const style::CrossLineAnimation &groupCallMemberInactiveCrossLine;
extern const style::CrossLineAnimation &groupCallMemberColoredCrossLine;
extern const style::icon &groupCallMemberInvited;
extern const style::point &groupCallMemberInvitedPosition;
extern const style::icon &groupCallMemberRaisedHand;
extern const style::IconButton &groupCallSettingsInner;
extern const style::IconButton &groupCallShareInner;
extern const style::IconButton &groupCallVideoInner;
extern const style::IconButton &groupCallHangupInner;
extern const style::CallButton &groupCallSettings;
extern const style::CallButton &groupCallShare;
extern const style::CallButton &groupCallVideo;
extern const style::IconButton &groupCallVideoInnerActive;
extern const style::CallButton &groupCallVideoActive;
extern const style::CallButton &groupCallHangup;
extern const style::CallButton &groupCallSettingsSmall;
extern const style::CallButton &groupCallHangupSmall;
extern const style::CallButton &groupCallVideoSmall;
extern const style::CallButton &groupCallVideoActiveSmall;
extern const style::CallButton &groupCallScreenShareSmall;
extern const style::CallButton &groupCallMenuToggleSmall;
extern const int &groupCallButtonSkip;
extern const int &groupCallButtonSkipSmall;
extern const int &groupCallButtonBottomSkip;
extern const int &groupCallButtonBottomSkipWide;
extern const style::margins &groupCallControlsBackMargin;
extern const int &groupCallControlsBackRadius;
extern const int &groupCallMuteBottomSkip;
extern const style::margins &groupCallMembersMargin;
extern const int &groupCallMembersTopSkip;
extern const int &groupCallMembersBottomSkip;
extern const int &groupCallMembersShadowHeight;
extern const int &groupCallMembersFadeSkip;
extern const int &groupCallMembersFadeHeight;
extern const style::GroupCallUserpics &groupCallTopBarUserpics;
extern const style::RoundButton &groupCallTopBarJoin;
extern const style::RoundButton &groupCallTopBarOpen;
extern const style::RoundButton &groupCallBoxButton;
extern const style::Box &groupCallBox;
extern const style::Box &groupCallLayerBox;
extern const style::LevelMeter &groupCallLevelMeter;
extern const style::icon &groupCallCheckboxIcon;
extern const style::Check &groupCallCheck;
extern const style::Radio &groupCallRadio;
extern const style::Checkbox &groupCallCheckbox;
extern const style::Toggle &groupCallSettingsToggle;
extern const style::SettingsButton &groupCallSettingsButton;
extern const style::SettingsButton &groupCallSettingsAttentionButton;
extern const style::FlatLabel &groupCallBoxLabel;
extern const style::FlatLabel &groupCallJoinAsLabel;
extern const int &groupCallJoinAsWidth;
extern const int &groupCallJoinAsTextTop;
extern const int &groupCallJoinAsNameTop;
extern const style::margins &groupCallJoinAsPadding;
extern const int &groupCallJoinAsPhotoSize;
extern const int &groupCallRowBlobMinRadius;
extern const int &groupCallRowBlobMaxRadius;
extern const style::LabelSimple &groupCallDelayLabel;
extern const style::margins &groupCallDelayLabelMargin;
extern const style::MediaSlider &groupCallDelaySlider;
extern const style::margins &groupCallDelayMargin;
extern const style::IconButton &groupCallTitleButton;
extern const style::icon &groupCallTitleMinimizeIcon;
extern const style::icon &groupCallTitleMinimizeIconOver;
extern const style::icon &groupCallTitleMaximizeIcon;
extern const style::icon &groupCallTitleMaximizeIconOver;
extern const style::icon &groupCallTitleRestoreIcon;
extern const style::icon &groupCallTitleRestoreIconOver;
extern const style::icon &groupCallTitleCloseIcon;
extern const style::icon &groupCallTitleCloseIconOver;
extern const style::WindowTitle &groupCallTitle;
extern const style::IconButton &groupCallPinOnTop;
extern const style::icon &groupCallPinnedOnTop;
extern const int &groupCallMajorBlobMaxRadius;
extern const int &groupCallMinorBlobIdleRadius;
extern const int &groupCallMinorBlobMaxRadius;
extern const style::CrossLineAnimation &groupCallMuteCrossLine;
extern const int &groupCallMenuSpeakerArcsSkip;
extern const style::margins &groupCallMenuVolumePadding;
extern const style::margins &groupCallMenuVolumeMargin;
extern const style::MediaSlider &groupCallMenuVolumeSlider;
extern const style::ArcsAnimation &groupCallSpeakerArcsAnimation;
extern const style::icon &groupCallStatusSpeakerIcon;
extern const int &groupCallStatusSpeakerArcsSkip;
extern const style::ArcsAnimation &groupCallStatusSpeakerArcsAnimation;
extern const style::margins &groupCallShareMutedMargin;
extern const style::CrossLineAnimation &callTopBarMuteCrossLine;
extern const style::FlatLabel &groupCallStartsIn;
extern const int &groupCallScheduledBodyHeight;
extern const style::FlatLabel &groupCallStartsWhen;
extern const int &groupCallStartsInTop;
extern const int &groupCallStartsWhenTop;
extern const style::font &groupCallCountdownFont;
extern const int &groupCallCountdownTop;
extern const style::margins &desktopCaptureMargins;
extern const style::size &desktopCaptureSourceSize;
extern const style::size &desktopCaptureSourceSkips;
extern const style::WindowTitle &desktopCaptureSourceTitle;
extern const style::margins &desktopCapturePadding;
extern const int &desktopCaptureLabelBottom;
extern const style::FlatLabel &desktopCaptureLabel;
extern const style::RoundButton &desktopCaptureCancel;
extern const style::RoundButton &desktopCaptureFinish;
extern const style::RoundButton &desktopCaptureSubmit;
extern const style::Checkbox &desktopCaptureWithAudio;
extern const int &groupCallNarrowSkip;
extern const int &groupCallNarrowMembersWidth;
extern const int &groupCallNarrowVideoHeight;
extern const int &groupCallWideModeWidthMin;
extern const style::size &groupCallWideModeSize;
extern const style::CrossLineAnimation &groupCallNarrowInactiveCrossLine;
extern const style::CrossLineAnimation &groupCallNarrowColoredCrossLine;
extern const style::icon &groupCallNarrowRaisedHand;
extern const style::icon &groupCallNarrowCameraIcon;
extern const style::icon &groupCallNarrowScreenIcon;
extern const style::icon &groupCallNarrowInvitedIcon;
extern const style::point &groupCallNarrowIconPosition;
extern const int &groupCallNarrowIconSkip;
extern const int &groupCallOutline;
extern const style::CrossLineAnimation &groupCallVideoCrossLine;
extern const style::GroupCallVideoTile &groupCallVideoTile;
extern const int &groupCallVideoSmallSkip;
extern const int &groupCallVideoLargeSkip;
extern const int &groupCallVideoPlaceholderHeight;
extern const int &groupCallVideoPlaceholderIconTop;
extern const int &groupCallVideoPlaceholderTextTop;
extern const style::Tooltip &groupCallTooltip;
extern const style::ImportantTooltip &groupCallNiceTooltip;
extern const style::FlatLabel &groupCallNiceTooltipLabel;
extern const style::ImportantTooltip &groupCallStickedTooltip;
extern const style::IconButton &groupCallStickedTooltipClose;
extern const int &groupCallNiceTooltipTop;
extern const style::icon &groupCallPaused;
extern const style::FlatLabel &groupCallRecordingSubLabel;
extern const style::margins &groupCallRecordingInfoMargins;
extern const style::margins &groupCallRecordingSubLabelMargins;
extern const int &groupCallRecordingAudioSkip;
extern const int &groupCallRecordingSelectWidth;
extern const int &groupCallRecordingInfoHeight;
extern const style::RoundButton &groupCallRtmpCopyButton;
extern const int &groupCallRtmpCopyButtonTopSkip;
extern const int &groupCallRtmpCopyButtonBottomSkip;
extern const style::IconButton &groupCallRtmpShowButton;
extern const style::IconButton &groupCallSettingsRtmpShowButton;
extern const style::FlatLabel &groupCallSubsectionTitle;
extern const style::RoundButton &groupCallAttentionBoxButton;
extern const int &groupCallRtmpUrlSkip;
extern const int &groupCallRtmpKeySubsectionTitleSkip;
extern const style::margins &groupCallRtmpSubsectionTitleAddPadding;
extern const style::point &groupCallRtmpShowButtonPosition;
extern const style::color &groupCallDividerBg;
extern const style::InputField &groupCallScheduleDateField;
extern const style::InputField &groupCallScheduleTimeField;
extern const style::icon &groupCallCalendarPreviousDisabled;
extern const style::icon &groupCallCalendarNextDisabled;
extern const style::IconButton &groupCallCalendarPrevious;
extern const style::IconButton &groupCallCalendarNext;
extern const style::CalendarColors &groupCallCalendarColors;
} // namespace st
