// WARNING! All changes made in this file will be lost!
// Created from 'chat_helpers.style' by 'codegen_style'
//
// This file is part of Desktop App Toolkit,
// a set of libraries for developing nice desktop applications.
//
// For license and copyright information please follow this link:
// https://github.com/desktop-app/legal/blob/master/LEGAL
//
#pragma once

#include "ui/style/style_core.h"

#include "styles/style_widgets.h"

namespace style {
namespace internal {

void init_style_chat_helpers(int scale);

} // namespace internal

struct RoundButton;
struct FlatLabel;
struct IconButton;
struct SettingsSlider;
struct ScrollArea;
struct PanelAnimation;
struct TextStyle;
struct Toast;
struct InnerDropdown;

struct TabbedSearch {
	style::color outer;
	style::color bg;
	style::color fg;
	style::color fgActive;
	style::icon fadeLeft;
	style::icon fadeRight;
	style::InputField field;
	style::IconButton search;
	style::IconButton back;
	style::CrossButton cancel;
	int defaultFieldWidth;
	int groupWidth;
	int groupSkip;
	int height;
};

struct EmojiPan {
	style::margins margin;
	style::margins padding;
	int desiredSize;
	int verticalSizeSub;
	int header;
	int headerLeft;
	int headerLockLeft;
	int headerLockedLeft;
	int headerTop;
	int footer;
	int iconSkip;
	int iconWidth;
	int iconArea;
	style::color bg;
	style::color overBg;
	style::color categoriesBg;
	style::color categoriesBgOver;
	style::icon fadeLeft;
	style::icon fadeRight;
	style::TabbedSearch search;
	style::margins searchMargin;
};

} // namespace style

namespace st {
extern const style::RoundButton &switchPmButton;
extern const style::FlatLabel &stickersRestrictedLabel;
extern const int &stickersTrendingHeader;
extern const int &stickersTrendingSkip;
extern const style::font &stickersTrendingHeaderFont;
extern const style::color &stickersTrendingHeaderFg;
extern const int &stickersTrendingHeaderTop;
extern const style::font &stickersTrendingSubheaderFont;
extern const style::color &stickersTrendingSubheaderFg;
extern const int &stickersTrendingSubheaderTop;
extern const int &emojiPanButtonRight;
extern const int &emojiPanButtonTop;
extern const style::RoundButton &emojiPanButton;
extern const style::RoundButton &emojiPanExpand;
extern const int &stickersTrendingAddTop;
extern const style::RoundButton &stickersTrendingAdd;
extern const style::IconButton &stickersRemove;
extern const style::RoundButton &stickersUndoRemove;
extern const int &stickersRemoveSkip;
extern const style::icon &stickersReorderIcon;
extern const int &stickersReorderSkip;
extern const style::SettingsSlider &stickersTabs;
extern const int &stickerEmojiSkip;
extern const style::font &stickersFeaturedBadgeFont;
extern const int &stickersFeaturedBadgeSize;
extern const int &stickersFeaturedBadgeTextTop;
extern const int &stickersFeaturedBadgePadding;
extern const int &stickersFeaturedBadgeSkip;
extern const int &stickersFeaturedBadgeTop;
extern const style::color &stickersFeaturedUnreadBg;
extern const int &stickersFeaturedUnreadSize;
extern const int &stickersFeaturedUnreadSkip;
extern const int &stickersFeaturedUnreadTop;
extern const style::icon &stickersFeaturedInstalled;
extern const int &stickersMaxHeight;
extern const style::margins &stickersPadding;
extern const style::size &stickersSize;
extern const style::margins &emojiSetPadding;
extern const int &emojiSetMaxHeight;
extern const style::size &emojiSetSize;
extern const style::ScrollArea &stickersScroll;
constexpr double stickersRowDisabledOpacity = 0.4;
constexpr int stickersRowDuration = 200;
extern const style::icon &stickersSettings;
extern const style::icon &stickersTrending;
extern const style::icon &stickersTrendingUnread;
extern const style::icon &emojiStatusDefault;
extern const style::IconButton &filtersRemove;
extern const style::margins &emojiPanMargins;
extern const style::SettingsSlider &emojiTabs;
extern const style::icon &emojiRecent;
extern const style::icon &emojiRecentActive;
extern const style::icon &emojiPeople;
extern const style::icon &emojiPeopleActive;
extern const style::icon &emojiNature;
extern const style::icon &emojiNatureActive;
extern const style::icon &emojiFood;
extern const style::icon &emojiFoodActive;
extern const style::icon &emojiActivity;
extern const style::icon &emojiActivityActive;
extern const style::icon &emojiTravel;
extern const style::icon &emojiTravelActive;
extern const style::icon &emojiObjects;
extern const style::icon &emojiObjectsActive;
extern const style::icon &emojiSymbols;
extern const style::icon &emojiSymbolsActive;
extern const int &emojiCategoryIconTop;
extern const style::PanelAnimation &emojiPanAnimation;
extern const int &emojiPanWidth;
extern const int &emojiPanMinHeight;
extern const int &emojiPanMaxHeight;
constexpr double emojiPanHeightRatio = 0.75;
constexpr int emojiPanShowDuration = 200;
constexpr int emojiPanDuration = 200;
extern const style::color &emojiPanHover;
constexpr int emojiPanSlideDuration = 200;
extern const style::size &emojiPanArea;
extern const int &emojiPanRadius;
extern const style::TabbedSearch &defaultTabbedSearch;
extern const style::EmojiPan &defaultEmojiPan;
extern const style::EmojiPan &statusEmojiPan;
extern const int &inlineResultsMinHeight;
extern const int &inlineResultsMaxHeight;
extern const style::font &emojiPanHeaderFont;
extern const int &emojiPanRemoveSkip;
extern const int &emojiPanRemoveTop;
extern const int &emojiColorsPadding;
extern const int &emojiColorsSep;
extern const style::color &emojiColorsSepColor;
extern const int &emojiIconSelectSkip;
extern const style::icon &emojiPremiumRequired;
extern const style::IconButton &hashtagClose;
extern const int &stickerPanWidthMin;
extern const style::size &stickerPanSize;
extern const int &stickerPanPadding;
extern const style::icon &stickerPanDeleteIconBg;
extern const style::icon &stickerPanDeleteIconFg;
constexpr double stickerPanDeleteOpacityBg = 0.3;
constexpr double stickerPanDeleteOpacityBgOver = 0.5;
constexpr double stickerPanDeleteOpacityFg = 0.8;
constexpr double stickerPanDeleteOpacityFgOver = 1;
extern const style::IconButton &stickerPanRemoveSet;
constexpr int stickerIconMove = 400;
constexpr int stickerPreviewDuration = 150;
constexpr double stickerPreviewMin = 0.1;
extern const int &stickerGroupCategorySize;
extern const style::TextStyle &stickerGroupCategoryAbout;
extern const style::margins &stickerGroupCategoryAddMargin;
extern const style::RoundButton &stickerGroupCategoryAdd;
extern const style::Toast &stickersToast;
extern const style::icon &stickersEmpty;
extern const style::icon &emojiEmpty;
extern const style::ScrollArea &inlineBotsScroll;
extern const style::margins &gifsPadding;
extern const style::InnerDropdown &emojiSuggestionsDropdown;
extern const int &emojiSuggestionSize;
extern const int &emojiSuggestionsScrolledWidth;
extern const style::margins &emojiSuggestionsPadding;
extern const int &emojiSuggestionsFadeAfter;
extern const int &mentionHeight;
extern const style::margins &mentionPadding;
extern const int &mentionTop;
extern const style::font &mentionFont;
extern const style::color &mentionNameFg;
extern const style::color &mentionNameFgOver;
extern const int &mentionPhotoSize;
extern const style::color &mentionBg;
extern const style::color &mentionBgOver;
extern const style::color &mentionFg;
extern const style::color &mentionFgOver;
extern const style::color &mentionFgActive;
extern const style::color &mentionFgOverActive;
extern const style::margins &autocompleteSearchPadding;
extern const style::margins &autocompleteRowPadding;
extern const style::TextStyle &autocompleteRowTitle;
extern const style::TextStyle &autocompleteRowKeys;
extern const style::TextStyle &autocompleteRowAnswer;
extern const int &manageEmojiPreview;
extern const int &manageEmojiPreviewWidth;
extern const int &manageEmojiPreviewHeight;
extern const style::margins &manageEmojiPreviewPadding;
extern const int &manageEmojiMarginRight;
extern const int &manageEmojiNameTop;
extern const int &manageEmojiStatusTop;
extern const int &inlineRadialSize;
extern const int &inlineFileSize;
extern const style::icon &stickersPremiumLock;
extern const style::margins &reactStripExtend;
extern const int &reactStripHeight;
extern const int &reactStripSize;
extern const int &reactStripMinWidth;
extern const int &reactStripImage;
extern const int &reactStripSkip;
extern const style::icon &reactStripBubble;
extern const int &reactStripBubbleRight;
extern const style::EmojiPan &userpicBuilderEmojiPan;
extern const style::EmojiPan &reactPanelEmojiPan;
extern const style::ScrollArea &emojiScroll;
extern const style::ScrollArea &reactPanelScroll;
extern const style::icon &emojiSuggestionsFadeLeft;
extern const style::icon &emojiSuggestionsFadeRight;
extern const style::icon &choosePeerGroupIcon;
extern const style::icon &choosePeerChannelIcon;
extern const int &choosePeerCreateIconLeft;
} // namespace st
