// WARNING! All changes made in this file will be lost!
// Created from 'media_view.style' by 'codegen_style'
//
// This file is part of Desktop App Toolkit,
// a set of libraries for developing nice desktop applications.
//
// For license and copyright information please follow this link:
// https://github.com/desktop-app/legal/blob/master/LEGAL
//
#pragma once

#include "ui/style/style_core.h"

namespace style {
namespace internal {

void init_style_media_view(int scale);

} // namespace internal

struct MediaSlider;
struct IconButton;
struct LabelSimple;
struct LinkButton;
struct MenuSeparator;
struct Menu;
struct Shadow;
struct PanelAnimation;
struct PopupMenu;
struct DropdownMenu;
struct TextStyle;
struct TextPalette;
struct WindowTitle;
struct MediaSpeedMenu;
struct MediaSpeedButton;
struct RoundButton;

} // namespace style

namespace st {
constexpr int mediaviewOverDuration = 150;
extern const style::MediaSlider &mediaviewPlayback;
extern const int &mediaviewPlaybackTop;
extern const int &mediaviewPlayProgressTop;
extern const style::IconButton &mediaviewControlsButton;
extern const style::size &mediaviewControllerSize;
extern const style::LabelSimple &mediaviewPlayProgressLabel;
extern const int &mediaviewPlayProgressSkip;
extern const int &mediaviewPlayProgressLeft;
extern const int &mediaviewPlayButtonTop;
extern const style::IconButton &mediaviewPlayButton;
extern const style::icon &mediaviewPauseIcon;
extern const style::icon &mediaviewPauseIconOver;
extern const int &mediaviewButtonsTop;
extern const int &mediaviewButtonsRight;
extern const int &mediaviewPipButtonSkip;
extern const style::IconButton &mediaviewPipButton;
extern const int &mediaviewFullScreenButtonSkip;
extern const style::IconButton &mediaviewFullScreenButton;
extern const style::icon &mediaviewFullScreenOutIcon;
extern const style::icon &mediaviewFullScreenOutIconOver;
extern const int &mediaviewVolumeWidth;
extern const int &mediaviewControllerRadius;
extern const style::icon &mediaviewVolumeIcon0;
extern const style::icon &mediaviewVolumeIcon0Over;
extern const style::icon &mediaviewVolumeIcon1;
extern const style::icon &mediaviewVolumeIcon1Over;
extern const style::icon &mediaviewVolumeIcon2;
extern const style::icon &mediaviewVolumeIcon2Over;
extern const int &mediaviewVolumeTop;
extern const int &mediaviewVolumeToggleLeft;
extern const style::IconButton &mediaviewVolumeToggle;
extern const int &mediaviewVolumeSkip;
extern const style::icon &mediaviewLeft;
extern const style::icon &mediaviewRight;
extern const style::icon &mediaviewSave;
extern const style::icon &mediaviewRotate;
extern const style::icon &mediaviewMore;
extern const style::icon &mediaviewFileRed;
extern const style::icon &mediaviewFileYellow;
extern const style::icon &mediaviewFileGreen;
extern const style::icon &mediaviewFileBlue;
extern const int &mediaviewFilePadding;
extern const style::size &mediaviewFileSize;
extern const int &mediaviewFileNameTop;
extern const style::font &mediaviewFileNameFont;
extern const int &mediaviewFileSizeTop;
extern const int &mediaviewFileExtTop;
extern const style::font &mediaviewFileExtFont;
extern const int &mediaviewFileExtPadding;
extern const int &mediaviewFileLinksTop;
extern const int &mediaviewFileIconSize;
extern const style::LinkButton &mediaviewFileLink;
extern const style::MenuSeparator &mediaviewMenuSeparator;
extern const style::Menu &mediaviewMenu;
extern const style::Shadow &mediaviewMenuShadow;
extern const style::PanelAnimation &mediaviewPanelAnimation;
extern const style::PopupMenu &mediaviewPopupMenu;
extern const style::DropdownMenu &mediaviewDropdownMenu;
extern const style::icon &mediaviewSaveMsgCheck;
extern const style::margins &mediaviewSaveMsgPadding;
extern const style::point &mediaviewSaveMsgCheckPos;
constexpr int mediaviewSaveMsgShowing = 200;
constexpr int mediaviewSaveMsgShown = 2000;
constexpr int mediaviewSaveMsgHiding = 2500;
extern const style::TextStyle &mediaviewSaveMsgStyle;
extern const style::TextPalette &mediaviewTextPalette;
extern const style::TextStyle &mediaviewCaptionStyle;
extern const style::font &mediaviewThickFont;
extern const style::font &mediaviewFont;
extern const style::TextStyle &mediaviewTextStyle;
extern const int &mediaviewTextLeft;
extern const int &mediaviewTextSkip;
extern const int &mediaviewHeaderTop;
extern const int &mediaviewTextTop;
extern const int &mediaviewControlSize;
extern const style::size &mediaviewIconSize;
extern const int &mediaviewIconOver;
constexpr int mediaviewWaitHide = 2000;
constexpr int mediaviewHideDuration = 1000;
constexpr int mediaviewShowDuration = 200;
constexpr int mediaviewFadeDuration = 150;
extern const int &mediaviewDeltaFromLastAction;
extern const int &mediaviewSwipeDistance;
extern const style::margins &mediaviewCaptionPadding;
extern const style::size &mediaviewCaptionMargin;
extern const int &mediaviewCaptionRadius;
extern const style::margins &mediaviewGroupPadding;
extern const int &mediaviewGroupHeight;
extern const int &mediaviewGroupWidth;
extern const int &mediaviewGroupWidthMax;
extern const int &mediaviewGroupSkip;
extern const int &mediaviewGroupSkipCurrent;
extern const int &mediaviewMinWidth;
extern const int &mediaviewMinHeight;
extern const int &mediaviewDefaultLeft;
extern const int &mediaviewDefaultTop;
extern const int &mediaviewDefaultWidth;
extern const int &mediaviewDefaultHeight;
extern const style::icon &mediaviewTitleMinimize;
extern const style::icon &mediaviewTitleMaximize;
extern const style::icon &mediaviewTitleRestore;
extern const style::icon &mediaviewTitleClose;
extern const style::IconButton &mediaviewTitleButton;
extern const style::WindowTitle &mediaviewTitle;
extern const style::icon &mediaviewTitleButtonMac;
extern const style::icon &mediaviewTitleMinimizeMac;
extern const style::icon &mediaviewTitleMaximizeMac;
extern const style::icon &mediaviewTitleRestoreMac;
extern const style::icon &mediaviewTitleCloseMac;
extern const style::margins &mediaviewTitleCloseMacPadding;
extern const style::margins &mediaviewTitleMinimizeMacPadding;
extern const style::margins &mediaviewTitleMaximizeMacPadding;
extern const style::icon &mediaviewShadowTop;
extern const style::icon &mediaviewShadowBottom;
extern const style::MediaSpeedMenu &mediaviewSpeedMenu;
extern const style::MediaSpeedButton &mediaviewSpeedButton;
extern const style::size &themePreviewSize;
extern const style::color &themePreviewBg;
constexpr double themePreviewOverlayOpacity = 0.8;
extern const style::margins &themePreviewMargin;
extern const int &themePreviewTitleTop;
extern const style::color &themePreviewTitleFg;
extern const style::font &themePreviewTitleFont;
extern const style::font &themePreviewLoadingFont;
extern const style::color &themePreviewLoadingFg;
extern const style::RoundButton &themePreviewApplyButton;
extern const style::RoundButton &themePreviewCancelButton;
extern const int &themePreviewButtonsSkip;
extern const int &themePreviewDialogsWidth;
extern const int &pipDefaultSize;
extern const int &pipMinimalSize;
extern const int &pipBorderSkip;
extern const int &pipBorderSnapArea;
extern const int &pipResizeArea;
extern const int &pipControlSkip;
extern const int &pipPlaybackWidth;
extern const int &pipPlaybackWide;
extern const int &pipPlaybackSkip;
extern const int &pipPlaybackTextSkip;
extern const style::font &pipPlaybackFont;
extern const style::icon &pipPlayIcon;
extern const style::icon &pipPlayIconOver;
extern const style::icon &pipPauseIcon;
extern const style::icon &pipPauseIconOver;
extern const style::icon &pipCloseIcon;
extern const style::icon &pipCloseIconOver;
extern const style::icon &pipEnlargeIcon;
extern const style::icon &pipEnlargeIconOver;
extern const style::icon &pipVolumeIcon0;
extern const style::icon &pipVolumeIcon0Over;
extern const style::icon &pipVolumeIcon1;
extern const style::icon &pipVolumeIcon1Over;
extern const style::icon &pipVolumeIcon2;
extern const style::icon &pipVolumeIcon2Over;
extern const style::size &speedSliderDividerSize;
} // namespace st
