// WARNING! All changes made in this file will be lost!
// Created from 'basic.style' by 'codegen_style'
//
// This file is part of Desktop App Toolkit,
// a set of libraries for developing nice desktop applications.
//
// For license and copyright information please follow this link:
// https://github.com/desktop-app/legal/blob/master/LEGAL
//
#pragma once

#include "ui/style/style_core.h"

namespace style {
namespace internal {

void init_style_basic(int scale);

} // namespace internal

struct TextPalette {
	style::color linkFg;
	style::color monoFg;
	style::color spoilerFg;
	style::color selectBg;
	style::color selectFg;
	style::color selectLinkFg;
	style::color selectMonoFg;
	style::color selectSpoilerFg;
	style::color selectOverlay;
	int linkAlwaysActive;
};

struct TextStyle {
	style::font font;
	style::font linkFont;
	style::font linkFontOver;
	int lineHeight;
};

} // namespace style

namespace st {
extern const int &fsize;
extern const style::font &normalFont;
extern const style::font &semiboldFont;
extern const int &boxFontSize;
extern const style::font &boxTextFont;
extern const int &emojiSize;
extern const int &emojiPadding;
extern const int &lineWidth;
extern const style::TextPalette &defaultTextPalette;
extern const style::TextStyle &defaultTextStyle;
extern const style::TextStyle &semiboldTextStyle;
constexpr int slideDuration = 240;
extern const int &slideShift;
extern const style::icon &slideShadow;
constexpr int slideWrapDuration = 150;
constexpr int fadeWrapDuration = 200;
extern const int &linkCropLimit;
extern const style::font &linkFont;
extern const style::font &linkOverFont;
extern const int &roundRadiusLarge;
extern const int &roundRadiusSmall;
extern const int &dateRadius;
extern const int &noContactsHeight;
extern const style::font &noContactsFont;
extern const style::color &noContactsColor;
constexpr int activeFadeInDuration = 500;
constexpr int activeFadeOutDuration = 3000;
extern const int &searchedBarHeight;
extern const style::font &searchedBarFont;
extern const style::point &searchedBarPosition;
extern const style::icon &smallCloseIcon;
extern const style::icon &smallCloseIconOver;
extern const style::font &dragFont;
extern const style::font &dragSubfont;
extern const style::color &dragColor;
extern const style::color &dragDropColor;
extern const style::margins &dragMargin;
extern const style::margins &dragPadding;
extern const int &dragHeight;
extern const style::size &radialSize;
extern const int &radialLine;
constexpr int radialDuration = 350;
constexpr int radialPeriod = 3000;
extern const style::size &locationSize;
constexpr int mediaPlayerSuppressDuration = 150;
extern const int &botDescSkip;
extern const int &inlineResultsLeft;
extern const int &inlineResultsSkip;
extern const int &inlineMediaHeight;
extern const int &inlineThumbSize;
extern const int &inlineThumbSkip;
extern const style::color &inlineTitleFg;
extern const style::color &inlineDescriptionFg;
extern const int &inlineRowMargin;
extern const int &inlineRowBorder;
extern const style::color &inlineRowBorderFg;
extern const int &inlineRowFileNameTop;
extern const int &inlineRowFileDescriptionTop;
extern const int &inlineResultsMinWidth;
extern const int &inlineDurationMargin;
extern const style::icon &historyReplyCancelIcon;
extern const style::icon &historyReplyCancelIconOver;
extern const style::icon &boxTitleCloseIcon;
extern const style::icon &boxTitleCloseIconOver;
extern const int &transparentPlaceholderSize;
extern const style::color &roundedFg;
extern const style::color &roundedBg;
} // namespace st
